#!/bin/bash
#script generates a dhcpd.conf file based on the NETWORK and NODESTARTIP parameters passed to it.  
#The list of MAC addresses is passed via stdin

#usage -- GenDHCPconf.sh <NETWORK> <NODESTARTIP> <DOMAINNAME> <OSVERSION>
NETWORK=$1
NODESTARTIP=$2
DOMAINNAME=$3
OSVERSION=$4

MASTERNAME=`hostname -s`
MASTERIP=`hostname -i`


SUSEVER=no
if [ -f /etc/SuSE-release ] ; then
  egrep -q "11.4|12.1|12.2|12.3" /etc/SuSE-release && SUSEVER=noddns
fi

#remove backup copy if existsS
if [ -f /etc/dhcpd.conf ] ; then mv /etc/dhcpd.conf /etc/dhcpd.conf-`/bin/date --iso-8601=minutes` ; fi
	
if [ $OSVERSION != "rh7.3" -a $OSVERSION != "fc17" -a $OSVERSION != "ubuntu" -a ${SUSEVER} != "noddns" ] ; then
   echo "ddns-update-style ad-hoc;" > /etc/dhcpd.conf
else
   > /etc/dhcpd.conf
fi

cat >>/etc/dhcpd.conf <<EOF
# enable network booting
allow booting;
allow bootp;

# set lease time to 3 days
default-lease-time 259200;
max-lease-time 259200;
EOF

echo "option domain-name \"$DOMAINNAME\";" >>/etc/dhcpd.conf
echo "option routers ${MASTERIP};" >> /etc/dhcpd.conf
echo "next-server ${MASTERIP};" >>/etc/dhcpd.conf

cat >>/etc/dhcpd.conf <<EOF
filename "/pxelinux.bin";
option vendor-encapsulated-options 09:0f:80:00:0c:4e:65:74:77:6f:72:6b:20:62:6f:6f:74:0a:07:00:50:72:6f:6d:70:74:06:01:02:08:03:80:00:00:47:04:80:00:00:00:ff;
EOF

echo "subnet ${NETWORK}0 netmask 255.255.254.0 {" >>/etc/dhcpd.conf

finishedmaster="no"
declare -i count
count=$NODESTARTIP
read MACS
for i in $MACS
do
  if [ $finishedmaster == "no" ] ; then
    echo "  host $MASTERNAME {" >> /etc/dhcpd.conf
    echo "    hardware ethernet $i;" >> /etc/dhcpd.conf
    echo "    fixed-address         ${MASTERIP};" >> /etc/dhcpd.conf
    echo "  }" >> /etc/dhcpd.conf
    finishedmaster="yes"
  else
    NODENAME=`grep "[0-9]*\.[0-9]*\.[0-9]*\.$count[^0-9]" /etc/hosts| grep -v 127\.0\.0 | head -1|awk '{print $3}'`
    echo "  host $NODENAME {" >> /etc/dhcpd.conf
    echo "    hardware ethernet $i;" >> /etc/dhcpd.conf
    echo "    fixed-address         ${NETWORK}${count};" >> /etc/dhcpd.conf
    echo "  }" >> /etc/dhcpd.conf
    count=$count+1
  fi
done
rangestart=`wc -l < /etc/nodes`
rangestart=`expr $rangestart + 2`
echo "  range ${NETWORK}${rangestart} ${NETWORK}249;" >> /etc/dhcpd.conf
echo "}" >>/etc/dhcpd.conf

if [ $OSVERSION == "fc17" ] ; then
  if [ -f /etc/dhcp/dhcpd.conf ] ; then mv /etc/dhcp/dhcpd.conf /etc/dhcp/dhcpd.conf-`/bin/date --iso-8601=minutes` ; fi
  mv /etc/dhcpd.conf /etc/dhcp/dhcpd.conf
fi
