#!/bin/bash
#usage gennodeconf.sh <MASTER TYPE> <NODE TYPE> <NODES FILE> <START IP> <SERIAL CONSOLE yes/no>
# ex- gennodeconf.sh opteron1u-6fans opteron1u-6fans /etc/nodes 1 yes
# this script will use any chassis type you specify. it does no error checking
MASTERTYPE=$1
NODETYPE=$2
NODES=$3
NODESTARTIP=$4
SERIAL=$5

declare -i count

echo "! This file defines the nodes in your cluster"
echo "! lines beginning with a ! are comments"
echo "\$EMAIL_ADDRESS noone@nowhere.com"
echo "\$EMAIL_SERVER 127.0.0.1"
echo "\$EMAIL_SENDER cluster@localhost"
echo "! can take multiple EMAIL_ADDRESS addresses separated by spaces."
echo "! email is sent whenever there is an alert condition, and whenever"
echo "! anything is shut down automatically by nodewatch."
echo "! setting ALERT_IGNORE to 1 prevents all alert/shutdown processing"
echo "! ALERT_IGNORE defaults to 1 for initial setup purposes"
echo "! OLD_ALERT is how many seconds after a loss of connectivity to a node before alerting"
echo "! EMAIL_REPEAT is how often in seconds to send reminders about a problem"
echo "\$ALERT_IGNORE 1"
echo "\$OLD_ALERT 60"
echo "\$EMAIL_REPEAT 120"
echo
count=$NODESTARTIP

MASTERIP=`hostname -i | awk 'BEGIN{FS="."}{print $4}'`
finishedmaster="no"

cat $NODES | while read i
do
	if [ $finishedmaster == "no" ] ; then
	  echo "\$NODE $MASTERIP $i"
          echo "\$\$CARDVERSION 0 0"
	  echo "\$\$CHASSIS $MASTERTYPE"
	  echo "\$\$MASTER"
	  echo "\$\$AUTOALERT 1"
          finishedmaster="yes"
	else
	  echo "\$NODE $count $i"
	  echo "\$\$CARDVERSION 0 0"
	  echo "\$\$CHASSIS $NODETYPE"
	  echo "\$\$AUTOALERT 1"
          [ "x$SERIAL" == "xyes" ] && echo "\$\$SERIALCONSOLE"
  	  count=$count+1
	fi
	echo
done


