<?php
// Execution of a file copy to all nodes of a cluster.
//
// Copyright (c) 2002 by Microway Inc., All rights reserved.
//
// Major modifications and rewrites by Rick Warner, from 2002-2007
//
// Revision history:
//      30Jul02 MJNewman: Add copy to a particular node.
//      16Jun02 MJNewman: Created
//
// Inputs:
//      fromfile        file to copy from (may include wildcards)
//      todir           directory to place the file into (expected to exist on all nodes)
require ("pagestuff.php");

pageInit (true);

if (!isset ($fromfile))
    $fromfile = "";
if (!isset ($todir))
    $todir = "";
if (!isset ($nodes) || ($nodes == "")) {
    $nodes = 'All';
};

pageStart ("Copy File Throughout Cluster");

if (isset ($_REQUEST['fromfile']))
    $fromfile = $_REQUEST['fromfile'];
if (isset ($_REQUEST['todir']))
    $todir = $_REQUEST['todir'];

microwayUserRequired ();

microwayCopyFile ($fromfile, $todir, $nodes);

echo "<h1>Copy File</h1>\n";
if ($fromfile != "") {
    $docopy = true;
    $file = @fopen ($fromfile, 'r');
    if (!$file) {
        $docopy = false;
        echo ("ERROR: File '$fromfile' does not exist can not copy it.<br>\n");
    };
    fclose ($file);
    if ($todir == "") {
        $docopy = false;
        echo ("ERROR: Destination directory must not be blank.<br>\n");
    };
    if ($docopy) {
        echo "<h2>Copy from $fromfile to $todir</h2>\n";
        echo "<p>";
        if (0 == strcasecmp ($nodes, "all")) {
            $result = microwayPerformCommand ("rcpf $fromfile $todir");
//      } else if (0 == strcasecmp($nodes,"master")) {
//          $result = microwayPerformCommand("cp $fromfile $todir");
        } else {
            $result = microwayPerformCommand ("rcp $fromfile $nodes:$todir");
        };
        echo "<textarea rows=15 cols=80>";
        echo $result;
        echo "</textarea>\n";
        echo "</p>";
    };
} else {
    echo ("No file to copy.<br>\n");
};

echo "<h2><a CLASS=menu HREF=clustercontrol.php>Return&nbsp;to&nbsp;Cluster&nbsp;Control</a></h2><br>\n";
pageEnd ();

?>
