<?php
// Services to read nodewatch data from interface files
//
// Copyright (c) 2002 by Microway Inc., All rights reserved.
//
// Major modifications and rewrites by Rick Warner, from 2002-2007
//
// Revision history:
//      20Sep02 MJNewman: history Created.
// Default interface file names

$microwayNodewatchDataFileName = "../data/nodewatch.dat";
$microwayNodewatchConfigFileName = "../data/autonodeconf.dat";

function microwayparseconfig ($filename) {
    global $microwayNodewatchData;
    global $microwayAlertLimits;

    $file = @fopen ($filename, 'r');
    if ($file == NULL)
        return "Can not open file $filename";
    $lineNumber = 0;
    if (!isset ($time))
        $time = 0;

    while (!feof ($file)) {
        $lineNumber += 1;
        $line = ltrim (rtrim (fgets ($file, 4096)));
        if ((strlen ($line) == 0) || ($line[0] == '!'))
            continue;
        $name = "";
        $name = "";
        $value1 = 0;
        $value2 = 0;
        $value3 = 0;
        $value4 = 0;
        $value5 = 0;
        $value6 = 0;
        $value7 = 0;
        $value8 = 0;
        $value9 = 0;
        $value10 = 0;
        $value11 = 0;
        $value12 = 0;
        $value13 = 0;
        $value14 = 0;
        $value15 = 0;
        $value16 = 0;
        $matches = sscanf ($line, " %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s", $name, $value1,
                           $value2, $value3, $value4, $value5, $value6, $value7, $value8, $value9, $value10, $value11, $value12, $value13, $value14, $value15, $value16);

        if (($name[0] == '$') && ($name[1] != '$')) {
            $nodeName = "";
        };

        switch (strtolower ($name)) {
        case '$node':
            $nodeName = $value1;
            if ($matches > 2)
                $nodeName = $value2;
            if (in_array ($nodeName, $microwayNodewatchData)) {
                $microwayNodewatchData[$nodeName] = array ();
            };
            $microwayNodewatchData[$nodeName]['TIME'] = $time;
            $microwayNodewatchData[$nodeName]['SERIALCONSOLE'] = false;
            $microwayNodewatchData[$nodeName]['MASTER'] = false;
            break;
        case '$$chassis':
            $microwayNodewatchData[$nodeName]['CHASSIS'] = $value1;
            break;
        case '$$fanlabels':
            $count = 0;
            $microwayNodewatchData[$nodeName]['FANNAMES'] = array ($value1, $value2, $value3, $value4, $value5, $value6, $value7, $value8, $value9, $value10, $value11, $value12, $value13);
            while ($microwayNodewatchData[$nodeName]['FANNAMES'][$count] != "") {
                $count++;
            }
            $microwayNodewatchData[$nodeName]['NUMFANS'] = $count;
            break;
        case '$$templabels':
            $count = 0;
            $microwayNodewatchData[$nodeName]['TEMPNAMES'] =
                array ($value1, $value2, $value3, $value4, $value5, $value6, $value7, $value8, $value9, $value10, $value11, $value12, $value13, $value14, $value15, $value16);
            while ($microwayNodewatchData[$nodeName]['TEMPNAMES'][$count] != "") {
                $count++;
            }
            $microwayNodewatchData[$nodeName]['NUMTEMPS'] = $count;
            break;
        case '$$voltlabels':
            $count = 0;
            $microwayNodewatchData[$nodeName]['VOLTNAMES'] = array ($value1, $value2, $value3, $value4, $value5, $value6, $value7, $value8, $value9, $value10, $value11);
            while ($microwayNodewatchData[$nodeName]['VOLTNAMES'][$count] != "") {
                $count++;
            }
            $microwayNodewatchData[$nodeName]['NUMVOLTS'] = $count;
            break;
        case '$$voltalertlo':
            $value1 /= 100;
            $value2 /= 100;
            $value3 /= 100;
            $value4 /= 100;
            $value5 /= 100;
            $value6 /= 100;
            $value7 /= 100;
            $value8 /= 100;
            $value9 /= 100;
            $value10 /= 100;
            $value11 /= 100;
            $microwayAlertLimits[$nodeName]['VOLTMIN'] = array ($value1, $value2, $value3, $value4, $value5, $value6, $value7, $value8, $value9, $value10, $value11);
            break;
        case '$$fanalertlo':
            $microwayAlertLimits[$nodeName]['FANMIN'] = array ($value1, $value2, $value3, $value4, $value5, $value6, $value7, $value8, $value9, $value10, $value11, $value12, $value13);
            break;
        case '$$tempalertlo':
            $value1 /= 100;
            $value2 /= 100;
            $value3 /= 100;
            $value4 /= 100;
            $value5 /= 100;
            $value6 /= 100;
            $value7 /= 100;
            $value8 /= 100;
            $value9 /= 100;
            $value10 /= 100;
            $value11 /= 100;
            $value12 /= 100;
            $value13 /= 100;
            $value14 /= 100;
            $value15 /= 100;
            $value16 /= 100;
            $microwayAlertLimits[$nodeName]['TEMPMIN'] =
                array ($value1, $value2, $value3, $value4, $value5, $value6, $value7, $value8, $value9, $value10, $value11, $value12, $value13, $value14, $value15, $value16);
            break;
        case '$$voltalerthi':
            $value1 /= 100;
            $value2 /= 100;
            $value3 /= 100;
            $value4 /= 100;
            $value5 /= 100;
            $value6 /= 100;
            $value7 /= 100;
            $value8 /= 100;
            $value9 /= 100;
            $value10 /= 100;
            $value11 /= 100;
            $microwayAlertLimits[$nodeName]['VOLTMAX'] = array ($value1, $value2, $value3, $value4, $value5, $value6, $value7, $value8, $value9, $value10, $value11);
            break;
        case '$$fanalerthi':
            $microwayAlertLimits[$nodeName]['FANMAX'] = array ($value1, $value2, $value3, $value4, $value5, $value6, $value7, $value8, $value9, $value10, $value11, $value12, $value13);
            break;
        case '$$tempalerthi':
            $value1 /= 100;
            $value2 /= 100;
            $value3 /= 100;
            $value4 /= 100;
            $value5 /= 100;
            $value6 /= 100;
            $value7 /= 100;
            $value8 /= 100;
            $value9 /= 100;
            $value10 /= 100;
            $value11 /= 100;
            $value12 /= 100;
            $value13 /= 100;
            $value14 /= 100;
            $value15 /= 100;
            $value16 /= 100;
            $microwayAlertLimits[$nodeName]['TEMPMAX'] =
                array ($value1, $value2, $value3, $value4, $value5, $value6, $value7, $value8, $value9, $value10, $value11, $value12, $value13, $value14, $value15, $value16);
            break;
            // begin shutdown limits
        case '$$voltshutdownlo':
            $value1 /= 100;
            $value2 /= 100;
            $value3 /= 100;
            $value4 /= 100;
            $value5 /= 100;
            $value6 /= 100;
            $value7 /= 100;
            $value8 /= 100;
            $value9 /= 100;
            $value10 /= 100;
            $value11 /= 100;
            $microwayAlertLimits[$nodeName]['VOLTSHUTMIN'] = array ($value1, $value2, $value3, $value4, $value5, $value6, $value7, $value8, $value9, $value10, $value11);
            break;
        case '$$fanshutdownlo':
            $microwayAlertLimits[$nodeName]['FANSHUTMIN'] = array ($value1, $value2, $value3, $value4, $value5, $value6, $value7, $value8, $value9, $value10, $value11, $value12, $value13);
            break;
        case '$$tempshutdownlo':
            $value1 /= 100;
            $value2 /= 100;
            $value3 /= 100;
            $value4 /= 100;
            $value5 /= 100;
            $value6 /= 100;
            $value7 /= 100;
            $value8 /= 100;
            $value9 /= 100;
            $value10 /= 100;
            $value11 /= 100;
            $value12 /= 100;
            $value13 /= 100;
            $value14 /= 100;
            $value15 /= 100;
            $value16 /= 100;
            $microwayAlertLimits[$nodeName]['TEMPSHUTMIN'] =
                array ($value1, $value2, $value3, $value4, $value5, $value6, $value7, $value8, $value9, $value10, $value11, $value12, $value13, $value14, $value15, $value16);
            break;
        case '$$voltshutdownhi':
            $value1 /= 100;
            $value2 /= 100;
            $value3 /= 100;
            $value4 /= 100;
            $value5 /= 100;
            $value6 /= 100;
            $value7 /= 100;
            $value8 /= 100;
            $value9 /= 100;
            $value10 /= 100;
            $value11 /= 100;
            $microwayAlertLimits[$nodeName]['VOLTSHUTMAX'] = array ($value1, $value2, $value3, $value4, $value5, $value6, $value7, $value8, $value9, $value10, $value11);
            break;
        case '$$fanshutdownhi':
            $microwayAlertLimits[$nodeName]['FANSHUTMAX'] = array ($value1, $value2, $value3, $value4, $value5, $value6, $value7, $value8, $value9, $value10, $value11, $value12, $value13);
            break;
        case '$$tempshutdownhi':
            $value1 /= 100;
            $value2 /= 100;
            $value3 /= 100;
            $value4 /= 100;
            $value5 /= 100;
            $value6 /= 100;
            $value7 /= 100;
            $value8 /= 100;
            $value9 /= 100;
            $value10 /= 100;
            $value11 /= 100;
            $value12 /= 100;
            $value13 /= 100;
            $value14 /= 100;
            $value15 /= 100;
            $value16 /= 100;
            $microwayAlertLimits[$nodeName]['TEMPSHUTMAX'] =
                array ($value1, $value2, $value3, $value4, $value5, $value6, $value7, $value8, $value9, $value10, $value11, $value12, $value13, $value14, $value15, $value16);
            break;
        case '$$serialconsole':
            $microwayNodewatchData[$nodeName]['SERIALCONSOLE'] = true;
            break;
        case '$$user':
            $microwayNodewatchData[$nodeName]['USER'] = $value1;
            break;
        case '$$password':
            $microwayNodewatchData[$nodeName]['PASSWORD'] = $value1;
            break;
        case '$$master':
            $microwayNodewatchData[$nodeName]['MASTER'] = true;
            break;

        default:
            break;
        }
    }
}


// Read nodewatch data from an interface file.
// Parse information into the global tables
//      microwayNodewatchData
//      microwayAlertLimits
// which is indexed by cluster name and then contains tables
// by parameter name.
//
// Inputs:
//      filename        file to read
// Returns:
//      error string which is empty if the file is read correctly
function microwayparsenodewatch ($filename) {
    global $microwayNodewatchData;
    global $microwayAlertLimits;
    $errorString = "";

    $file = @fopen ($filename, 'r');
    if ($file == NULL)
        return "Can not open file $filename";
    $lineNumber = 0;
    $version = 1;
    $nodeName = "";
    $time = 0;
    while (!feof ($file)) {
        $lineNumber += 1;
        $line = ltrim (rtrim (fgets ($file, 4096)));
        if ((strlen ($line) == 0) || ($line[0] == '!'))
            continue;
        $name = "";
        $value1 = 0;
        $value2 = 0;
        $value3 = 0;
        $value4 = 0;
        $value5 = 0;
        $value6 = 0;
        $value7 = 0;
        $value8 = 0;
        $value9 = 0;
        $value10 = 0;
        $value11 = 0;
        $value12 = 0;
        $value13 = 0;
        $value14 = 0;
        $value15 = 0;
        $value16 = 0;
        $matches = sscanf ($line, " %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s", $name, $value1,
                           $value2, $value3, $value4, $value5, $value6, $value7, $value8, $value9, $value10, $value11, $value12, $value13, $value14, $value15, $value16);

        if (($name[0] == '$') && ($name[1] != '$')) {
            $nodeName = "";
        };
        $noNodeNeeded = false;
        switch (strtolower ($name)) {
        case '$version':
            $version = $value1;
            if ($version != 1) {
                $errorString .= "WARNING: Unexpected version $version on line $lineNumber\n";
            };
            break;
        case '$node':
            $nodeName = $value1;
            if ($matches > 2)
                $nodeName = $value2;
            if (in_array ($nodeName, $microwayNodewatchData)) {
                $microwayNodewatchData[$nodeName] = array ();
            };
            $microwayNodewatchData[$nodeName]['TIME'] = $time;
            break;
        case '$time':
            if (!is_numeric ("0x$value1")) {
                $errorString .= "ERROR: Time $value1 is not numeric on line $lineNumber.\n";
            };
            $time = hexdec ($value1);
            break;
        case '$$power':
            $microwayNodewatchData[$nodeName]['SWITCHON'] = ($value1) ? 1 : 0;
            break;
        case '$$temp':
            $value1 /= 100.0;
            if ($value1 > 300)
                $value1 = -100;
            $value2 /= 100.0;
            if ($value2 > 300)
                $value2 = -100;
            $value3 /= 100.0;
            if ($value3 > 300)
                $value3 = -100;
            $value4 /= 100.0;
            if ($value4 > 300)
                $value4 = -100;
            $value5 /= 100.0;
            if ($value5 > 300)
                $value5 = -100;
            $value6 /= 100.0;
            if ($value6 > 300)
                $value6 = -100;
            $value7 /= 100.0;
            if ($value7 > 300)
                $value7 = -100;
            $value8 /= 100.0;
            if ($value8 > 300)
                $value8 = -100;
            $value9 /= 100.0;
            if ($value9 > 300)
                $value9 = -100;
            $value10 /= 100.0;
            if ($value10 > 300)
                $value10 = -100;
            $value11 /= 100.0;
            if ($value11 > 300)
                $value11 = -100;
            $value12 /= 100.0;
            if ($value12 > 300)
                $value12 = -100;
            $value13 /= 100.0;
            if ($value13 > 300)
                $value13 = -100;
            $value14 /= 100.0;
            if ($value14 > 300)
                $value14 = -100;
            $value15 /= 100.0;
            if ($value15 > 300)
                $value15 = -100;
            $value16 /= 100.0;
            if ($value16 > 300)
                $value16 = -100;
            $microwayNodewatchData[$nodeName]['TEMP'] =
                array ($value1, $value2, $value3, $value4, $value5, $value6, $value7, $value8, $value9, $value10, $value11, $value12, $value13, $value14, $value15, $value16);
            break;
        case '$$volt':
            $value1 /= 100.0;
            $value2 /= 100.0;
            $value3 /= 100.0;
            $value4 /= 100.0;
            $value5 /= 100.0;
            $value6 /= 100.0;
            $value7 /= 100.0;
            $value8 /= 100.0;
            $microwayNodewatchData[$nodeName]['VOLT'] = array ($value1, $value2, $value3, $value4, $value5, $value6, $value7, $value8);
            break;
        case '$$fan':
/*			    $value1 /= 1.0;
			    $value2 /= 1.0;
			    $value3 /= 1.0;
			    $value4 /= 1.0;
			    $value5 /= 1.0;
			    $value6 /= 1.0;
			    $value7 /= 1.0;
			    $value8 /= 1.0;
			    $value9 /= 1.0;
			    $value10 /= 1.0;
			    $value11 /= 1.0;*/
            $microwayNodewatchData[$nodeName]['FAN'] = array ($value1, $value2, $value3, $value4, $value5, $value6, $value7, $value8, $value9, $value10, $value11, $value12, $value13);
            break;
        case '$$cfg':
            // do nothing with $$CFG lines for now
            break;
        default:
            $noNodeNeeded = true;
            break;
        };
        if (!$noNodeNeeded && ((0 == strncmp ($name, '$$', 2)) && ($nodeName == ""))) {
            $errorString .= "ERROR: content found without associated node\n";
        };
    };
    fclose ($file);

    return $errorString;
}

?>
