<?php
// Interface routines that isolate Microway from changes to Ganglia.
//
// Major modifications and rewrites by Rick Warner, from 2002-2007
//
// Revision History:
//    02Jul02 MJNewman: Created.

$mypath = realpath ('.');
chdir ("..");
include_once "conf.php";
include_once "ganglia.php";
include_once "functions.php";
include_once "get_context.php";
include_once "get_ganglia.php";
chdir ($mypath);

// Get a list of hosts in the cluster.
//
// Returns:
//      an array with index of host name and content of IP address
//      hosts with no name will have an index of their IP address.
function mw2gHostsOfCluster () {
    if (false) {
        global $clusters;
        global $hosts;
        global $hosts_down;

        $hostList = array ();
        if (!is_array ($clusters)) {
            return $hostList;
        };
        foreach ($clusters as $cname => $cvalue) {
            if (is_array ($hosts[$cname])) {
                foreach ($hosts[$cname] as $node => $nodeInfo) {
                    $hostList[$nodeInfo[NAME]] = $nodeInfo[IP];
                };
            };
        };
        foreach ($clusters as $cname => $cvalue) {
            if (is_array ($hosts_down[$cname])) {
                foreach ($hosts_down[$cname] as $node => $nodeInfo) {
                    $hostList[$nodeInfo[NAME]] = $nodeInfo[IP];
                };
            };
        };
        uksort ($hostList, "strnatcmp");
    } else {
        global $hosts_up;
        global $hosts_down;
        $hostList = array ();
        foreach ($hosts_up as $cname => $cvalue) {
            $hostList[$cname] = $cvalue;
        };
        foreach ($hosts_down as $cname => $cvalue) {
            $hostList[$cname] = $cvalue;
        };
        uksort ($hostList, "strnatcmp");
    };
    return $hostList;
}

// Get a list of hosts that are up in the cluster.
//
// Returns:
//      an array with index of host name and content of IP address
//      hosts with no name will have an index of their IP address.
function mw2gHostsUpOfCluster () {
    if (false) {
        global $clusters;
        global $hosts;

        $hostList = array ();
        if (!is_array ($clusters)) {
            return $hostList;
        };
        foreach ($clusters as $cname => $cvalue) {
            if (is_array ($hosts[$cname])) {
                foreach ($hosts[$cname] as $node => $nodeInfo) {
                    $hostList[$nodeInfo[NAME]] = $nodeInfo[IP];
                };
            };
        };
        uksort ($hostList, "strnatcmp");
        return $hostList;
    } else {
        global $hosts_up;
        $hostList = $hosts_up;
        uksort ($hostList, "strnatcmp");
        return $hostList;
    };
}

// Get a list of hosts that are part of the cluster and presently down.
//
// Returns:
//      an array with index of host name and content of IP address
//      hosts with no name will have an index of their IP address.
function mw2gHostsDownOfCluster () {
    if (false) {
        global $clusters;
        global $hosts_down;

        $hostList = array ();
        if (!is_array ($clusters)) {
            return $hostList;
        };
        foreach ($clusters as $cname => $cvalue) {
            if (is_array ($hosts_down[$cname])) {
                foreach ($hosts_down[$cname] as $node => $nodeInfo) {
                    $hostList[$nodeInfo[NAME]] = $nodeInfo[IP];
                };
            };
        };
        uksort ($hostList, "strnatcmp");
        return $hostList;
    } else {
        global $hosts_down;
        $hostList = $hosts_down;
        uksort ($hostList, "strnatcmp");
        return $hostList;
    };
}

?>
