<?php
// Execution of a command on node(s) of a cluster.
//
// Copyright (c) 2002 by Microway Inc., All rights reserved.
// Richard Warner 4/21/03 Created
//
// Major modifications and rewrites by Rick Warner, from 2002-2007
//
require ("pagestuff.php");
pageInit (true);

pageStart ("Node Backup");

microwayUserRequired ();

$basebackupdir = "/drive";
$slotready[1] = file_exists ("$basebackupdir/backups/Slot1/done");
$slotready[2] = file_exists ("$basebackupdir/backups/Slot2/done");
$slotready[3] = file_exists ("$basebackupdir/backups/Slot3/done");
$slotready[4] = file_exists ("$basebackupdir/backups/Slot4/done");
$slotready[5] = file_exists ("$basebackupdir/backups/Slot5/done");
$slotready[6] = file_exists ("$basebackupdir/backups/Slot6/done");

for ($i = 1; $i <= 6; $i++) {
    if ($slotready[$i]) {
        if (file_exists ("$basebackupdir/backups/Slot$i/comment")) {
            $comment[$i] = file_get_contents ("$basebackupdir/backups/Slot$i/comment");
            if (!isset ($comment[$i]) || $comment[$i] == "")
                $comment[$i] = "No comment";
        } else
            $comment[$i] = "No comment";
    } else
        $comment[$i] = "Empty";
}

echo "<FORM method=post action=processbackup.php>\n";

echo "<TABLE WIDTH=\"95%\">\n";
echo "<TR><TH COLSPAN=10>MCMS Node backup</TH></TR>";
echo "<TR align=center><TD colspan=10>Please note that your current backup will overwrite the prior one.</TD></TR>\n";
echo "<TR><TD COLSPAN=10><HR></TD></TR>";

//BEGIN prompting for data

//pick golden node
echo "<TR><TD>Please select node to be backed up:</TD>\n";
echo "<TD>";
echo microwayNodeSelect ("", false, false, "nodes");
echo "</TD>";
echo "<TR><TD>&nbsp;</TD></TR>";


echo "<TR><TD>Please choose backup slot:</TD>\n";
echo "<TD><select name=backupslot>\n";
echo "<option value=\"Slot1\">Slot 1 - $comment[1]</option>\n";
echo "<option value=\"Slot2\">Slot 2 - $comment[2]</option>\n";
echo "<option value=\"Slot3\">Slot 3 - $comment[3]</option>\n";
echo "<option value=\"Slot4\">Slot 4 - $comment[4]</option>\n";
echo "<option value=\"Slot5\">Slot 5 - $comment[5]</option>\n";
echo "<option value=\"Slot6\">Slot 6 - $comment[6]</option>\n";
echo "</select></TD></TR>\n";

echo "<TR><TD>Optional comment field for this backup slot:</TD><TD><INPUT name=comment type=text size=40></TD></TR>\n";

$masterip = exec ('hostname -i | awk \'{print $1}\'');
$masterip = trim ($masterip);

//specify config options different from default
// FIXME - probe system for eth module rather than use e1000e by default  -- 2011-9-12: now it does a list instead
echo "<TR><TD>Modify config options if necessary:<BR>";
echo "<I>Option explanations:<BR>";
echo "MASTER-IP of master node<BR>";
echo "DEVICES-hard drives in node to be backed up<BR>";
echo "ETHMODS-network modules to be loaded the restoration</I></TD>";
echo "<TD><TEXTAREA NAME=config ROWS=5 COLS=40>MASTER=\"".$masterip."\"\n";
echo "DEVICES=\"/dev/sda\"\n";
echo "ETHMODS=\"e1000e igb e1000 forcedeth tg3 ixgbe ixgb\"</TEXTAREA></TD></TR>";
echo "<TR><TD>&nbsp;</TD></TR>";

//prompt for excluded directories
echo "<TR><TD>Enter any directories that you do not want backed up. Enter one directory per line.  NFS mounted directories will automatically be exluded already.<BR>\n";
echo "<I>Example:</I><BR>\n";
echo "<TABLE border=1><TR><TD>/scratch/tempdata<BR>\n";
echo "/data</TD></TR></TABLE></TD>";

echo "<TD><TEXTAREA NAME=excludes ROWS=5 COLS=40></TEXTAREA></TD></TR>\n";
echo "<TR><TD>&nbsp;</TD></TR>";

//submit/reset
echo "<TR><TD COLSPAN=10 align=center><INPUT type=submit name=\"Backup now\" VALUE=\"Backup now\">&nbsp;&nbsp;\n";
echo "&nbsp;<INPUT type=reset NAME=Reset></TD></TR>\n";

echo "</TABLE>";


pageEnd ();

?>
