<?PHP
$basebackupdir = "/drive";
$slotready[1] = file_exists ("$basebackupdir/backups/Slot1/done");
$slotready[2] = file_exists ("$basebackupdir/backups/Slot2/done");
$slotready[3] = file_exists ("$basebackupdir/backups/Slot3/done");
$slotready[4] = file_exists ("$basebackupdir/backups/Slot4/done");
$slotready[5] = file_exists ("$basebackupdir/backups/Slot5/done");
$slotready[6] = file_exists ("$basebackupdir/backups/Slot6/done");

for ($i = 1; $i <= 6; $i++) {
    if ($slotready[$i]) {
        if (file_exists ("$basebackupdir/backups/Slot$i/comment")) {
            $comment[$i] = file_get_contents ("$basebackupdir/backups/Slot$i/comment");
            if (!isset ($comment[$i]) || $comment[$i] == "")
                $comment[$i] = "No comment";
        } else
            $comment[$i] = "No comment";
    } else
        $comment[$i] = "Empty";
}

require ("pagestuff.php");
pageInit (true);
pageStart ("Node Restoration");
microwayUserRequired ();

if (!$slotready[1] && !$slotready[2] && !$slotready[3] && !$slotready[4] && !$slotready[5] && !$slotready[6]) {
    $inprogress = system ("grep \"Backup in progress\" /tmp/backup-progress.html");
    if ($inprogress == "") {
        echo "A backup must be created before a restoration can be performed. Please go to the\n";
        echo "<A HREF=\"nodebackup.php\">Node Backup</A> page to create one.\n";
        pageEnd ();
        exit ();
    } else {
        echo "A backup is in progress.  Please wait for it to finish before beginning a restore.<BR>\n";
        echo "You can monitor the progress <A HREF=\"checkbackup.php\">here</A>.\n";
        pageEnd ();
        exit ();
    }
}


$current = readlink ("$basebackupdir/backups/current");

echo "<TABLE>\n";
echo "<TR><TH COLSPAN=20>Node Restoration</TH></TR>\n";
echo "<TR><TD>The current backup slot is $current.  The current backup slot is used for restorations.\n";
echo "If you wish to change the current backup slot, please select it below.</TR></TR>";

$backupoptions = "<SELECT name=currentslot>";

for ($i = 1; $i <= 6; $i++) {
    if ($slotready[$i]) {
        if ($current == "Slot$i") {
            $backupoptions .= "<option value=\"Slot$i\" SELECTED>Slot $i - $comment[$i]</option>";
        } else {
            $backupoptions .= "<option value=\"Slot$i\">Slot $i - $comment[$i]</option>";
        }
    }
}

$backupoptions .= "</select>";

echo "<TR><FORM method=POST action=changebackupslot.php><TD align=center>\n";
echo "$backupoptions&nbsp;&nbsp;&nbsp;&nbsp;<INPUT type=submit name=submit value=\"Change Current Slot\"></TD></FORM></TR>";

echo "<TR><TD>&nbsp;</TD></TR>\n";
echo "<TR><TD>A node can be netbooted to begin a restoration.  For a netboot install, most newer systems provide a means to select network boot on reboot.  F12, F11, F8, and escape are likely possibilities.  Failing that, simply reboot the system in question, enter the bios, and set netboot(may be listed as pxe, iba, or mba in your bios) to boot prior to the hard disk.</TD></TR>\n";
echo "<TR><TD>The network boot system will download a kernel and an initrd image from the master. These are stored in /tftpboot on the master.  This initrd image contains the node restoration software.  The restore will begin automatically.  Once completed, the system will prompt you for a node number and then reboot automatically. If the system was netbooted via a changed bios boot order, you will need to go back into the bios and set the hard drive to boot instead of the netboot.</TD></TR>\n";
pageEnd ();

?>
