<?php
// Set node power
//
// Copyright (c) 2002 by Microway Inc., All rights reserved.
//
// Major modifications and rewrites by Rick Warner, from 2002-2007
//
// Revision history:
//      20Sep02 MJNewman: Use nodewatch list of nodes instead of Ganglia list
//       9Sep02 MJNewman: Add control power of all nodes.
//      10Jul02 MJNewman: Created
//
// Inputs:
//      power           OFF to turn power off, ON to turn it on
//      nodeName        name of node to control 'all' for all but master
require ("pagestuff.php");
include_once ("microwayparsenodewatch.php");

pageInit (true);

if (isset ($_REQUEST['nodeName']))
    $nodeName = $_REQUEST['nodeName'];
if (isset ($_REQUEST['power']))
    $power = $_REQUEST['power'];

if (!isset ($nodeName))
    microwayErrorPage ("No Node name to control");
if (!isset ($power))
    microwayErrorPage ("No power setting for node $nodeName");

pageStart ("Node Power");
microwayUserRequired ();

$masterName = trim (microwayPerformCommandLocally ("hostname -s"));
$masterIP = trim (microwayPerformCommandLocally ("hostname -i"));

echo "<h1>Queue power $power for $nodeName</h1>\n";

switch (strtolower ($power)) {
case 'off':
    $powerSymbol = 'p';
    break;
case 'reset':
    $powerSymbol = 'r';
    break;
default:
case 'on':
    $powerSymbol = 'P';
    break;
};
if (strtolower ($nodeName) == 'all') {
    if ($masterName == "") {
        echo "ERROR: could not identify the master node<br>";
        pageEnd ();
        exit ();
    };

    echo "<h2><a CLASS=menu HREF=clustercontrol.php>Return&nbsp;to&nbsp;Cluster&nbsp;Control</a></h2><br>\n";


    global $microwayNodewatchData;
    global $microwayNodewatchDataFileName;
    $microwayNodewatchData = array ();
    $result = microwayparsenodewatch ($microwayNodewatchDataFileName);
    if ($result != "") {
        echo "<b>ERROR:</b> $result<br><br>\n";
    };
    if (is_array ($microwayNodewatchData)) {
        foreach ($microwayNodewatchData as $name => $v) {
            if (($name == $masterName) || ($name == $masterIP))
                continue;
            if ($_SESSION['usesIPMI'] != "yes") {
                echo microwayPerformCommand ("/usr/local/sbin/nodecontrol"." -o../data/nodecommands-temp.dat -$powerSymbol $name");
            } else {
                echo microwayPerformCommand ("/usr/local/sbin/nodecontrol"." -o../data/nodecommands.dat -$powerSymbol $name");
            }
            echo "<br>\n";
        };
        if ($_SESSION['usesIPMI'] != "yes")
            microwayPerformCommand ("mv ../data/nodecommands-temp.dat ../data/nodecommands.dat");
    };
} else {
    echo microwayPerformCommand ("/usr/local/sbin/nodecontrol -o../data/nodecommands.dat -$powerSymbol $nodeName");
};

echo "<h2><a CLASS=menu HREF=clustercontrol.php>Return&nbsp;to&nbsp;Cluster&nbsp;Control</a></h2><br>\n";

pageEnd ();

?>
