#!/usr/bin/perl


my $DATADIR="/var/www/html/ganglia/data";
open(AUTOCONF, '<', "$DATADIR/autonodeconf.dat") or die $!;
@autonodeconf = <AUTOCONF>;
close(AUTOCONF);

open(HOSTS, '<', "/etc/hosts") or die $!;
@hosts = <HOSTS>;
close(HOSTS);

my $count=0;
my $node="nullnode";
my $ip="0.0.0.0";
my %FANS;
my %TEMPS;
my %VOLTS;


foreach $line (@autonodeconf) {
  if ($line =~ /^\$NODE/) {
    @breakout = split(/ /,$line);
    $node = $breakout[2];
    chomp($node);
  }
 
  if ($line =~ /^\$\$FANLABELS/) {
    @labels = split(/ /, substr($line, 13));
    $count=0;
    foreach $label (@labels) {
      chomp($label);
      $FANS{"$node $count"}=$label;
      $count++;
    }
  }
  if ($line =~ /^\$\$TEMPLABELS/) {
    @labels = split(/ /, substr($line, 14));
    $count=0;
    foreach $label (@labels) {
      chomp($label);
      $TEMPS{"$node $count"}=$label;
      $count++;
    }
  }
  if ($line =~ /^\$\$VOLTLABELS/) {
    @labels = split(/ /, substr($line, 14));
    $count=0;
    foreach $label (@labels) {
      chomp($label);
      $VOLTS{"$node $count"}=$label;
      $count++;
    }
  }
}


open(DAT, '<', "$DATADIR/nodewatch.dat") or die $!;
@nodedat = <DAT>;
close(DAT);



sub nodeIP {
  my $myresult="";
  my $thisnode = $_[0];
  foreach $hostline (@hosts) {
    if ($hostline =~ /$thisnode[^-0123456789]/) {
      @thisone=split(/\s/,$hostline);
      $myresult=$thisone[0];
    }
  }
  return($myresult);
}


foreach $line (@nodedat) {

  if ($line =~ /^\$NODE/) {
    @breakout = split(/ /,$line);
    $node = $breakout[2];
    chomp($node);
    $ip = &nodeIP($node);
  }
 
  if ($line =~ /^\$\$FAN/) {
    @values = split(/ /, substr($line, 6));
    $count=0;
    foreach $value (@values) {
      chomp($value);
      system("/usr/bin/gmetric -n Fan-" . $FANS{"$node $count"} . " -t int16 -v $value -u RPM -S $ip:$node"); 
      $count++;
    }
  }
  if ($line =~ /^\$\$TEMP/) {
    @values = split(/ /, substr($line, 7));
    $count=0;
    foreach $value (@values) {
      chomp($value);
      $value/=100;
      system("/usr/bin/gmetric -n Temp-" . $TEMPS{"$node $count"} . " -t float -v $value -u Celcius -S $ip:$node"); 
      $count++;
    }
  }
  if ($line =~ /^\$\$VOLT/) { 
    @values = split(/ /, substr($line, 7));
    $count=0;
    foreach $value (@values) {
      chomp($value);
      $value/=100;
      system("/usr/bin/gmetric -n Volt-" . $VOLTS{"$node $count"} . " -t float -v $value -u Volts -S $ip:$node"); 
      $count++;
    }
  }
}



