#define MAXSENSORS 50
#define MAXCHASSIS 50
#define MAXCHASSISNAME 30
#define MAXNODENAME 30

#define MAXEMAILSIZE 262144  //256k is a pretty damn big mail for just plain text alerts
#define MAXEMAILADDRESS 512
#define MAXEMAILSUBJECT 1024
#define MAXEMAILSERVER 256
#define MAXEMAILRECIPIENTS 8

#define MAXSENSORNAME 22
#define MAXNODES 512
#define MAXFANS 32
#define MAXTEMPS 32
#define MAXVOLTS 16
#define MAXDATADIR 256
#define DEFAULTDATADIR "/srv/www/htdocs/ganglia/data"

#define CHASSISDAT "chassis.dat"
#define CLUSTERDAT "cluster.dat"
#define NODEWATCHDAT "nodewatch.dat"
#define AUTONODECONFDAT "autonodeconf.dat"
#define NODECOMMANDSDAT "nodecommands.dat"

#define QUERY_DELAY 5  //5 seconds in between node readings
#define ALERT_DELAY 180 //180 seconds after first reading before ALERTS start being processed

#define IPMIPORT "623"
#define OUTPUTFREQ 10  //30 seconds between nodewatch.dat updates
#define RSH "/usr/bin/rsh"
#define ALERTHARDFREQUENCY 60*15  //do not report a problem again unless at least 15 minutes have passed 
#define ALERTSOFTFREQUENCY 60*7  //if you're already reporting anyway, reduce the limit to 7 minutes. I think
                                 //to ensure eventual grouping of all alerts, this value should be less than
                                 //half of the HARD frequency
#define CRITFREQUENCY 45         //time until handling a crit is only 45 secs - time is there just to allow shutdown to complete and clear alert prior to alert being processed again
#define GLOBALFREQUENCY 60*2     //if an alert for an additional system comes in after already sending an unrelated alert, it must wait 2 minutes.  This helps group alerts of many systems starting to overheat at once

#define ERROROUTPUT stderr  //when it is time to log to file, this will be changed

/////////////ENUMS/////////

enum { POWEROFF,POWERON,RESET }; //commands
enum { NORMAL, COMMAND_FAIL, MISC }; //return values
enum { CRITLOW, ALERTLOW, ALERTHIGH, CRITHIGH };
enum { FAN, TEMP, VOLT };
enum { ALERT_STATUS_IDLE,       // nothing happening.
  ALERT_STATUS_SPUN,            // thread was just spun off.
  ALERT_STATUS_BUSY,            // thread is working.
  ALERT_STATUS_DONE,            // thread is done, body memory must be freed!
  ALERT_STATUS_ERROR
}; 
