// controller function codes

// remote sensor node

#define ADR 'A'                 // set new slave node address
#define RST 'X'                 // software reset
#define NOP 'N'                 // no operation
#define A2D 'D'|RES             // analog to digital conversion
#define ANA 'C'|RES             // all analog channels
#define KEY 'K'|RES             // keyboard/program/remote key hit
#define LLM 'L'                 // lower limit
#define ULM 'U'                 // upper limit
#define NOM 'M'                 // out of alarm value
#define SER 'S'|RES             // serial number
#define TAC 'T'|RES             // single tachometer
#define TCA 'F'|RES             // all tachometers

// Extra power codes:

#define NODE_RESET 'R'          // reset node.
#define NODE_ON 'P'             // power node on.
#define NODE_OFF 'p'            // power node off.
#define NODE_TOGGLE 'o'         // powercycle node.

// serial console on/off
#define NODE_RS422_ON  'G'       // turn on  rs422 serial console
#define NODE_RS422_OFF 'g'       // turn off rs422 serial console

// Flash read-write-erase codes below:
// All are |RES because the card will send back an acknowledgement
// packet (not the network ACK) after the process has been completed.

#define FLASH_WRITE 'W'|RES
#define FLASH_READ  'B'|RES
#define FLASH_ERASE 'E'|RES

// Note that for flash-stored data that is only understood
// by the master, the master manages the memory map and format.
// However, for slave-understood data, the master has to 
// read to determine which of two consecutive locations
// contains the active packet, then it must store to the 
// inactive packet and lastly atomically inactivate the currently 
// active packet.  It does that by erasing the packet
// if it's the first one, or writing the activation byte 
// to the first one if it's the second one.
