#include <stdlib.h>
#include <memory.h>
// #include <gsci.h>
// #include <commlib.h>
// #include <fast.h>
#include "timer.h"
#include "net.h"
// #include "eventwai.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <stdio.h>
#include <sys/time.h>           // the SYS is very important!
#include "syslogging.h"
extern unsigned char flash_override;
extern struct timeval tv1, tv2;
extern int nodaemon;

PACKET Message;
PACKET Response;
QUEUE QueueMessage;
QUEUE QueueResponse;

unsigned char ucNetState;
unsigned char ucRcvState;


// the following manages receiving serial characters:

int fd, res;
int my_ring_start, my_ring_size;
int read_buf;                   // size of possibly reading the serial port
int read_buf_act;               // size of actually reading the serial port
/* ring_start is the index into the first valid
   byte in the ring buffer.  ring_size is the buffer's
   total size.  The ring buffer is large enough to receive
   multiple packets before resetting these counters. */

int serstatus;                  // MLJ for modifying RTS and DTR bits.
struct termios oldtio, newtio;

unsigned char buf[RING_BUF_SIZE];       // from non-con linux
unsigned char read_bufchar;     // the character just read from buffer


bit bDone;                      // packet assembled
bit bCrcOK;                     // received CRC equals transmited CRC

int j;

static unsigned char ucNakCount;

static PACKET *pMessage;
static SPACKET msg = { 2, 0, 0 };

// msg is specially used to send POLs!!!!!  because code is 0.

// PORT *port;

////// Following from non cannonical linux example:




void netOpen (  )
{
  netCallBackInit (  );

  my_ring_start = 0;
  my_ring_size = 0;

  fd = open ( MODEMDEVICE, O_RDWR | O_NOCTTY | O_NONBLOCK );    /* MLJ added nonblock */
  if ( fd < 0 ) {
    perror ( MODEMDEVICE );
    exit ( -1 );
  }
/*  if (flock(fd,LOCK_EX) != 0) {
	  perror(MODEMDEVICE);
	  exit(-2);
  }*/

  tcgetattr ( fd, &oldtio );    /* save current port settings */

  bzero ( &newtio, sizeof ( newtio ) );
  newtio.c_cflag = BAUDRATE | CS8 | CLOCAL | CREAD;
  //CRTSCTS has been eliminated
  // when this is done correctly using ands and ors
  // of existing status, CRTSCTS must be anded out.
  newtio.c_iflag = IGNPAR;

  newtio.c_oflag = NOFLSH;

  /* set input mode (non-canonical, no echo,...) */
  newtio.c_lflag = 0;

  newtio.c_cc[VTIME] = 0;       /* inter-character timer unused */
  newtio.c_cc[VMIN] = 10;       /* blocking read until 5 chars received  1MLJ  */

  tcflush ( fd, TCIOFLUSH );
  tcsetattr ( fd, TCSANOW, &newtio );
  ioctl ( fd, TIOCMGET, &serstatus );   // get status bits
  serstatus |= ( TIOCM_RTS | TIOCM_DTR );       //set RTS and DTR
  ioctl ( fd, TIOCMSET, &serstatus );   // write status back



  /*
     #ifdef DOS
     Change8259Priority(CIRQ);
     if (is16550(COM_PORT))
     {
     FastSet16550UseTXFifos(ON);
     FastSet16550TriggerLevel(TRIGGER_04);
     }

     port = PortOpenGreenleafFast(COM_PORT, BAUDRATE, 'N', 8, 1);
     if (port->status != ASSUCCESS)
     exit(0);
     SetRts(port, TRANSMIT);
     SetDtr(port, ON);
     #else
     port = PortOpenGreenleaf(COM_PORT, BAUDRATE, 'N', 8, 1);
     if (port->status != ASSUCCESS)
     exit(0);
     SetRts(port, TRANSMIT);
     SetDtr(port, ON);
     #endif

     ClearRXBuffer(port);
     ClearTXBuffer(port); */
}

void netClose (  )
{
  close ( fd );                 /* MLJ close serial port */
  //  PortClose(port);
}

void netProcess (  )
{
  // Netprocess alternately receives and sends packets.
  // For each packet sent, an ACK is expected back.
  // For each packet received, an ACK is sent back in response.
  // These ACKs are at a lower level and in addition to the 
  // idea that a packet might
  // be a request for actual information.  For example, if
  // all analog channels are requested, the PC sends a request
  // for all analog channels.  Then the card sends back
  // first an ACK for the request, followed by another packet
  // with the data itself.  Finally, the PC returns an ACK
  // for the response data.

  // For interpretation of specific kinds of packets, see
  // netexecu.c and execnode.c

  //   (*states[ucNetState])();
  char tmp_error[400];

  switch ( ucNetState ) {
     case NET_MESSAGE:

       // Net message in this version will always send something.
       // if there is something to be sent, it will send it and 
       // enqueue a poll to be sent right after.
       // if a poll was enqueued to be sent, that won't however cause
       // an endless loop.

       // if there was nothing enqueued to be sent, then the pollunit()
       // will return the next unit in line to be polled and that
       // general poll will be sent.
       // Mike is changing this now.   If there was nothing to be sent,
       // no general poll will be sent.


       // in any case, NetState being NET_MESSAGE will always
       // lead to NetState becoming NET_RESPONSE right after.

       //static void netMessage()
       {
         unsigned char ucPriority;
         msg.ucCode = POL;
         if ( ( pMessage = dequeue ( &QueueMessage, &ucPriority ) ) == NULL ) {

           // We try to send units messages that are in the Message
           // Queue.  IF there are NO pending messages in the Message
           // Queue, THEN we poll units for general status.

           //           msg.ucUnit = pollUnit (  );

           msg.ucUnit = 1;      // HACK to get out of fixing the polling unit bug.
           if ( flash_override != 10 )
             error_msg ( "No queue. polled unit.  Are all cards dead?\n" );
           // you NEVER want to poll a unit!  that's why requestprocess
           // keeps a couple of extra messages queued up.
           pMessage = ( PACKET * ) & msg;
         } else {
           // Okay, what is really going on here:
           // Above, the determination was made concerning whether
           // this is a poll or a real message.
           // below, an if statement redecides this fact (spaghetti,
           // the following code could have been above...)
           // originally, Ed determined that any message that is not a 
           // pol message, requires a response.  Then, he hacked 
           // the message code byte meanings so a response bit (bit 7)
           // set indicates to the following line of code, that 
           // the message is going to receive a response.

           // however, it's still not clear why the message needs to
           // be enqueued in the message queue if anyhow it will
           // be netTransmitted in the subsequent line!

           // Ah HAH!  Just figured it out.  If a dequeued message requires
           // a response, then in addition to sending the original dequeued message
           // now, (pMessage),  we also enqueue a mid-priority pol to make sure the
           // target is woken up or somesuch.  The variable msg declared static above
           // is 2 0 0 which is really a POL (code 0).  So the mid-priority pol is 
           // set up to go next time around, to the same unit targeted this time.
           // Even if the priority of the current (real) message in pMessage is 
           // less than the mid-priority pol, the pol will wait because we are already
           // sending the pMessage now.

           // 8-16-2002:
           // the purpose of sending the pol is to make sure the card has a reason to switch 
           // back to the transmit state to give the response.
           // In other words, the state machine on the card requires it to receive a packet
           // for every packet it wants to transmit.  Since pols do not requires acks to be sent 
           // back to the master, sending the pol permits the card's state machine to
           // transition to transmit mode which allows it to transmit the
           // response.  This assumes that the card is able to generate
           // and enqueue the needed response before the pol is received.
           // Therefore, on the card, the response should be generated and equeued 
           // by BLOCKING code called by the card's receive state machine, to ensure
           // the card does not go around a cycle of receiving the pol before it
           // has generated the response that the pol is allowing to go through.

           // this is clearly a design flaw.  What we should do is either time out
           // or allow cards to transmit their entire transmit queue contents
           // in one shot when they transmit.  In this case, we are going to
           // be depending on the buffering mechanism of Linux to receive and store
           // up the entire multi-packet response before the Linux user software (daemon)
           // has a chance to transmit again, thereby avoiding potential collisions.

#if 0                           // equivalent to commenting out the following line...
           if ( pMessage->ucCode != POL )
#else
           if ( pMessage->ucCode & RES )        // force immediate respose via poll
#endif
           {
             msg.ucUnit = pMessage->ucUnit;
             enqueue ( &QueueMessage, ( PACKET * ) & msg, MID_PRIORITY );
             // this poll is above the typical request priority in requestprocess().
           }
         }

         netTransmit ( pMessage, RECEIVE );

         setTimeout ( TIMER_NET, NET_TIMEOUT );
         ucNetState = NET_RESPONSE;
         break;
       }
     case NET_RESPONSE:

       // 7/25/02  I think there is a bug in this part of the code.
       // I have seen cases where the stereo jack is disconnected
       // and then re-connected, and the transmissions blink
       // every 1/2 second or so.  Valid data stops flowing.

       // I think this is an endless loop caused by constantly
       // starting to read in the 'middle' of a packet.

       // This can easily happen if the attention signal 0x01 sent
       // by the card is sent at any other time as part of any data.
       // for instance as the ID to CARD 1 !!!!!  What the F*CK 
       // protocol uses such a widely-overloaded symbol for attention?

       // This bug may come and go based on the particular max packet
       // size that happens to be chosen.

       // possible solutions to the bug include making the attention more unique
       // (different and/or 2 bytes)
       // and/or using special timeouts or failsafes to make requests for data
       // and all polls slow down until all flow of data has ceased
       // to allow things to 'reset' themselves if they get out of hand.
       // also, esp. if a NAK should arrive this is a good indication that
       // it's time clear things out, stop sending requests, and wait
       // for no more data and start again from scratch.

       // In addition to all of this, I need to reduce the net timeout,
       // so as soon as the actual flow of bytes stops, I can resume
       // transmitting requests for more data.  Also, 
       // once a packet is lost don't go for multiple resend-retry attempts
       // if no ACK is received or if a NAK


       //static void netResponse()
       {
         /* In the first version, I will read the port.
            If the port gives me more than one byte, I will
            issue an error.  Howver, the right way is for me to save
            multiply read bytes until next time I am called here.    Actually, this is taken care of by the third parameter to read, the 1 indicating to read one byte.  */
         // First try to read everything in from the serial buffer.
         // into internal ring buffer.
         // then try to process bytes read in.

         /* my_ring_start is the index into the first valid
            byte in the ring buffer.  my_ring_size is the buffer's
            total size.  The ring buffer is large enough to receive
            multiple packets before resetting these counters. */


         ioctl ( fd, FIONREAD, &read_buf );
         if ( read_buf > 0 )    // characters available in serial buf
         {
           if ( ( my_ring_start + my_ring_size + read_buf ) > RING_BUF_SIZE )
             error_msg ( "ERROR: ring buffer overrun\n" );
           else {
             read_buf_act =
               read ( fd, buf + my_ring_start + my_ring_size, read_buf );

             if ( read_buf != read_buf_act ) {
               sprintf ( tmp_error, "ERROR -- didn't read port \n"
                         "expected: %d\nactual: %d\n", read_buf,
                         read_buf_act );
               error_msg ( tmp_error );
             }
             my_ring_size += read_buf_act;      // increase size of buffer.
           }
         }
         // above we checked for new bytes from port, reading 
         // into ring buffer.
         // below we check for old bytes in ring buffer, and use one.

         if ( my_ring_size > 0 ) {
           read_bufchar = buf[my_ring_start];
           my_ring_size--;      // one less character in ring buffer
           if ( my_ring_size == 0 )
             my_ring_start = 0; // reset the ring buffer
           else
             my_ring_start++;   // move to next character in ring buffer.

           // now go on and process that character:

           if ( netReceive ( read_bufchar ) )   // MLJ

           {
             if ( bCrcOK ) {
               switch ( Response.ucCode ) {
                  case ACK:
                    // If it's an ack for something other than a poll
                    // ie an ack for a real request, then 
                    // go into message (transmit) mode.
                    ucNakCount = 0;

                    if ( pMessage->ucCode != POL )
                      // There is a state machine that involves
                      // a complicated interrelated dance among the host and teh slave.
                      // pols are commands issued from the master
                      // to the slave telling the slave to go into
                      // transmit mode.

                      // If the slave is acking a pol, you know it's going into 
                      // transmit mode, so you stay in receive mode.
                      // otherwise, you can give your next netmessage.

                    {
                      //    SetRts(port, TRANSMIT);
                      ioctl ( fd, TIOCMGET, &serstatus );       // get status bits
                      serstatus |= ( TIOCM_RTS | TIOCM_DTR );   //set RTS and DTR
                      ioctl ( fd, TIOCMSET, &serstatus );       // write status back

                      usleep ( TURN_AROUND );
                      ucNetState = NET_MESSAGE;
                    }
                    break;

                  case NAK:
                    //  SetRts(port, TRANSMIT);

                    // If it's a NAK, retransmit the message,
                    // a certain number of times, or else
                    // start from the beginning.
                    error_msg ( "RECEIVED NAK!\n" );
                    //PUT THIS BACK
                    ioctl ( fd, TIOCMGET, &serstatus ); // get status bits
                    serstatus |= ( TIOCM_RTS | TIOCM_DTR );     //set RTS and DTR
                    ioctl ( fd, TIOCMSET, &serstatus ); // write status back
                    usleep ( TURN_AROUND );
                    if ( ++ucNakCount > MAX_NAK ) {
                      ucNakCount = 0;
                      ucRcvState = RCV_SYNC;
                      ucNetState = NET_MESSAGE;
                    } else {
                      // EXCUSE ME, dont' you need to RTS transmit?
                      // YES, it was done just above.
                      netTransmit ( pMessage, RECEIVE );
                      setTimeout ( TIMER_NET, NET_TIMEOUT );
                    }
                    break;
                    // WHY BREAK
                  default:
                    //    SetRts(port, TRANSMIT);
                    ioctl ( fd, TIOCMGET, &serstatus ); // get status bits
                    serstatus |= ( TIOCM_RTS | TIOCM_DTR );     //set RTS and DTR
                    ioctl ( fd, TIOCMSET, &serstatus ); // write status back
                    usleep ( TURN_AROUND );
                    ucNakCount = 0;
                    //STORE THE RESPONSE
                    enqueue ( &QueueResponse, &Response, MIN_PRIORITY );
                    msg.ucUnit = Response.ucUnit;
                    msg.ucCode = ACK;
                    // TRANSMIT AN ACK FOR THE RESPONSE right away.
                    // error_msg("sending ACK");
                    netTransmit ( ( PACKET * ) & msg, TRANSMIT );
                    ucNetState = NET_MESSAGE;
               }
             } else             // CRC is NOT ok
             {
               //       SetRts(port, TRANSMIT);
               ioctl ( fd, TIOCMGET, &serstatus );      // get status bits
               serstatus |= ( TIOCM_RTS | TIOCM_DTR );  //set RTS and DTR
               ioctl ( fd, TIOCMSET, &serstatus );      // write status back
               usleep ( TURN_AROUND );
               if ( ++ucNakCount > MAX_NAK ) {
                 ucNakCount = 0;
                 ucRcvState = RCV_SYNC;
                 ucNetState = NET_MESSAGE;
               } else {
                 // TRY SENDING OUT A NAK FOR THE BAD CRC...
                 // But with this ack and nak business, dont'
                 // you assume you've got the right unit?
                 error_msg ( "SENDING NAK!\n" );
                 msg.ucUnit = Response.ucUnit;
                 msg.ucCode = NAK;
                 netTransmit ( ( PACKET * ) & msg, RECEIVE );
                 setTimeout ( TIMER_NET, NET_TIMEOUT );
               }

             }
             // end of netreceive if. --- do NOT netmessage,
             // you are still receiving more data, leave RTS receiving.
             // waiting for more data for packet.
           }
         } else                 // Nothing was read at all.
         {
           if ( isTimeout ( TIMER_NET ) ) {

             //   SetRts(port, TRANSMIT);
             ioctl ( fd, TIOCMGET, &serstatus );        // get status bits
             serstatus |= ( TIOCM_RTS | TIOCM_DTR );    //set RTS and DTR
             ioctl ( fd, TIOCMSET, &serstatus );        // write status back
             ucNakCount = 0;
             //    ClearRXBuffer(port);
             // ClearTXBuffer(port);

             tcflush ( fd, TCIOFLUSH );

             // above from open code to clear buffer.

             ucRcvState = RCV_SYNC;
             ucNetState = NET_MESSAGE;
             // THE FOLLOWING WOULD HAVE GOTTEN US INTO AN ENDLESS LOOP
             // EXCEPT THAT THE SOFTWARE ALSO DOES NOT KNOW WHICH
             // ACK IS FOR WHICH UNIT'S PACKET!  AS A RESULT,
             // BEFORE COMMENTING THIS OUT IT WAS A RACE CONDITION
             // FOR ANOTHER PACKET TO BE QUEUED AFTER THIS MAX-PRIORITY
             // PACKET BUT BEFORE ITS TIMEOUT...??


             // the following was removed to let the system 'move on'
             // more rapidly:
             /*               if (pMessage->ucCode != POL)
                enqueue(&QueueMessage, pMessage, MAX_PRIORITY);  */
           }                    // end of if timeout
         }                      // end of noread
         break;
       }
  }
}

/* static const void (*states[])() = {netMessage,
   netResponse};
   BEING REPLACED BY
   CASE-SWITCH */
