#include <stdio.h>
#include <ctype.h>
#include "net.h"
//#include "line.h"

extern unsigned char ucRcvState;
extern PACKET Response;
extern CRC crc;

bit bCrcOK;
bit bDone;

static unsigned char ucChar, ucIndex, ucCount;
static CRC rcv;


bit netReceive ( unsigned char character )
{
  // This is a little state machine that receives bytes and
  // organizes them into valid packets.
  ucChar = character;

  switch ( ucRcvState ) {
     case RCV_SYNC:

       //static void stateSync()                // sync on SOH
       {
         //printf("RCV_SYNC");
         if ( ucChar == SOH ) {
           //printf("ucChar==SOH");
           bCrcOK = FALSE;
           crc.uCRC = 0;
           calCRC ( ucChar );
           ucRcvState = RCV_LENGTH;
         }

         bDone = FALSE;
         break;
       }

     case RCV_LENGTH:
       //static void stateLength()      // Response length
       {
         //printf("RCV_LENGTH");
         Response.ucLength = ucChar;
         ucCount = ucChar;
         calCRC ( ucChar );
         if ( ucCount == 0 )
           ucRcvState = RCV_CRC1;
         // If there's no data, go straight to the CRC.
         // (no data for ACKs and NAKs)
         else if ( ucCount > ( MAX_DATA + 2 ) )
           ucRcvState = RCV_SYNC;
         else
           ucRcvState = RCV_UNIT;
         break;
       }
     case RCV_UNIT:
//static void stateUnit()               // controller address
       {
         //printf("RCV_UNIT");
         Response.ucUnit = ucChar;
         calCRC ( ucChar );
         if ( --ucCount == 0 )
           ucRcvState = RCV_CRC1;
         else
           ucRcvState = RCV_CODE;
         break;
       }
     case RCV_CODE:
//static void stateCode()               // code field
       {
         //printf("RCV_CODE");
         Response.ucCode = ucChar;
         calCRC ( ucChar );
         if ( --ucCount == 0 )
           ucRcvState = RCV_CRC1;
         else {
           ucIndex = 0;
           ucRcvState = RCV_DATA;
         }
         break;
       }
     case RCV_DATA:
//static void stateData()               // information field
       {
         //printf("RCV_DATA");
         Response.ucaData[ucIndex++] = ucChar;
         calCRC ( ucChar );
         if ( --ucCount == 0 )
           ucRcvState = RCV_CRC1;
         break;
       }
     case RCV_CRC1:
//static void stateCRC1()               // first CRC byte
       {
         //printf("RCV_CRC1");
         rcv.byte.ucHigh = ucChar;
         ucRcvState = RCV_CRC2;
         break;
       }
     case RCV_CRC2:
//static void stateCRC2()               // second CRC byte
       {
         //printf("RCV_CRC2");

         rcv.byte.ucLow = ucChar;
         bDone = TRUE;
         bCrcOK = FALSE;
         if ( crc.uCRC == rcv.uCRC )
           bCrcOK = TRUE;
         ucRcvState = RCV_SYNC;
         break;
       }

  }
  return ( bDone );
}

/* static const void *states[]() = {stateSync,
                                   stateLength,
                                   stateUnit,
                                   stateCode,
                                   stateData,
                                   stateCRC1,
                                   stateCRC2};
*/

/*  MLJ is reworking this to be a case-switch
    rather than an array of pointers to functions
    (yuck!) */
