// Callbacks that parse $DO_ sections
//
// Modification History:
//    13Aug02 MJNewman: Created.

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "cardconfig.h"
#include "net.h"
#include "exec.h"
#include "limits.h"
#include "codes.h"

//??? proper include file for power control definition
extern int power_ctl ( char *nodeName, char power_cmd, char seconds );
void serviceNewSection (  )
{
  return;
}


// called to parse a line in local context
//
// Inputs:
//      line            line being read
//      lineNumber      used for error reporting
//      fieldName       $xxx from the first thing on the line
//      nodeName        second field on the line
//      value1          third field on the line
void serviceFieldLine ( char *line, int lineNumber, int matches,
                        char *fieldName, char *nodeName, char *value1 )
{
  if ( 0 == stricmp ( fieldName, "$DO_POWER_CYCLE" ) ) {
    if ( matches < 2 ) {
      fprintf ( stderr,
                "ERROR: no node name for $DO_POWER_CYCLE on line %d\n",
                lineNumber );
    };
    power_ctl ( nodeName, NODE_TOGGLE, 0 );
  };
  if ( 0 == stricmp ( fieldName, "$DO_POWER_OFF" ) ) {
    if ( matches < 2 ) {
      fprintf ( stderr, "ERROR: no node name for $DO_POWER_OFF on line %d\n",
                lineNumber );
    };
    power_ctl ( nodeName, NODE_OFF, 0 );
  };
  if ( 0 == stricmp ( fieldName, "$DO_POWER_ON" ) ) {
    if ( matches < 2 ) {
      fprintf ( stderr, "ERROR: no node name for $DO_POWER_ON on line %d\n",
                lineNumber );
    };
    power_ctl ( nodeName, NODE_ON, 0 );
  };
  if ( 0 == stricmp ( fieldName, "$DO_KEY_LOCK" ) ) {
    if ( matches < 2 ) {
      fprintf ( stderr, "ERROR: no node name for $DO_KEY_LOCK on line %d\n",
                lineNumber );
    };
    fprintf ( stderr, "NIY: $DO_KEY_LOCK on line %d\n", lineNumber );

//???   power_ctl(nodeName,NODE_KEYLOCK_ON,0);
  };
  if ( 0 == stricmp ( fieldName, "$DO_KEY_UNLOCK" ) ) {
    if ( matches < 2 ) {
      fprintf ( stderr,
                "ERROR: no node name for $DO_KEY_UNLOCK on line %d\n",
                lineNumber );
    };
    fprintf ( stderr, "NIY: $DO_KEY_UNLOCK on line %d\n", lineNumber );

//???   power_ctl(nodeName,NODE_KEYLOCK_OFF,0);
  };
  if ( 0 == stricmp ( fieldName, "$DO_RESET" ) ) {
    if ( matches < 2 ) {
      fprintf ( stderr, "ERROR: no node name for $DO_RESET on line %d\n",
                lineNumber );
    };
    power_ctl ( nodeName, NODE_RESET, 0 );
  };
  if ( 0 == stricmp ( fieldName, "$DO_SET_NODENAME" ) ) {
    if ( matches < 2 ) {
      fprintf ( stderr,
                "ERROR: no node name for $DO_SET_NODENAME on line %d\n",
                lineNumber );
    };
    if ( matches < 3 ) {
      fprintf ( stderr,
                "ERROR: no new node name for $DO_SET_NODENAME on line %d\n",
                lineNumber );
    };

//???       DO_SET_NODENAME(nodeName,value1);
  };
  if ( 0 == stricmp ( fieldName, "$DO_RS422_ON" ) ) {
    if ( matches < 2 ) {
      fprintf ( stderr, "ERROR: no node name for $DO_RS422_ON on line %d\n",
                lineNumber );
    };
    power_ctl ( nodeName, NODE_RS422_ON, 0 );
  };
  if ( 0 == stricmp ( fieldName, "$DO_RS422_OFF" ) ) {
    if ( matches < 2 ) {
      fprintf ( stderr, "ERROR: no node name for $DO_RS422_OFF on line %d\n",
                lineNumber );
    };
    power_ctl ( nodeName, NODE_RS422_OFF, 0 );
  };
  return;
}
