// This file contains the commands to manipulate power control features.
// You can turn on, turn off, powercycle, and reset a node.
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "cardconfig.h"
#include "net.h"
#include "exec.h"
#include "codes.h"
#include "timer.h"
#include "limits.h"

extern CLUSTERNODE *ClusterList;

CLUSTERNODE *searchNodeIP ( char *nodeIP )
     // tries to locate a node when given the node name.
{
  CLUSTERNODE *loopNode = ClusterList;

  while ( loopNode != NULL ) {
    if ( 0 == stricmp ( loopNode->ipaddress, nodeIP ) ) {
      return ( loopNode );
    } else {
      loopNode = loopNode->nextnode;
    }
  }
  return ( NULL );              // couldn't find it.  
}


int return_nodenum ( char *name_orig )
{
  char *name = name_orig;
  int numdots = 0;
  int return_val;
  while ( numdots != 3 ) {
    if ( name[0] == '.' )
      numdots++;
    name = &name[1];
  }
  //now all that is left in name is the node number
  sscanf ( name, "%d", &return_val );
  return ( return_val );
}

// the following packets are FROM the PC TO the CARD
// to REQUEST the action.

extern QUEUE QueueMessage;
extern int nodaemon;

int power_ctl ( char *nodeName, char power_cmd, char seconds )
{
  CLUSTERNODE *foundNode;
  int nodeNumber;
  PACKET pow;

  // ???This never used to return 0 there is code in the caller to
  // handle that, why?
  if ( nodaemon )
    fprintf ( stderr, "! Power command %c on node name %s\n", power_cmd,
              nodeName );
  if ( nodeName == NULL )
    return 1;
  foundNode = searchNodeIP ( nodeName );


  if ( foundNode == NULL ) {
    // ???Add code to look up the number for a node name if a name
    // is passed in.
    if ( nodaemon )
      fprintf ( stderr, "! Translate node name %s\n", nodeName );
    return 1;
  };

  nodeNumber = foundNode->cardaddress;

  if ( nodaemon )
    fprintf ( stderr, "%d\n", nodeNumber );
  pow.ucLength = 2;
  pow.ucUnit = ( char ) nodeNumber;
  pow.ucCode = power_cmd;

  enqueue ( &QueueMessage, &pow, MAX_PRIORITY );

  //  usleep(4000000);
  return ( 1 );
}

int power_ctl_fromnode ( CLUSTERNODE * foundNode, char power_cmd )
{
  int nodeNumber;
  PACKET pow;

  if ( foundNode == NULL ) {
    // ???Add code to look up the number for a node name if a name
    // is passed in.
    if ( nodaemon )
      fprintf ( stderr,
                "! pwr_control_fromnode was called with null node!\n" );
    return 1;
  };

  nodeNumber = foundNode->cardaddress;

  if ( nodaemon )
    fprintf ( stderr, "%d\n", nodeNumber );
  pow.ucLength = 2;
  pow.ucUnit = ( char ) nodeNumber;
  pow.ucCode = power_cmd;

  enqueue ( &QueueMessage, &pow, MAX_PRIORITY );

  //  usleep(4000000);
  return ( 1 );
}


/*int reset_node ( int nodenum )
{                               //'Reset node' function - should be called to interact with MikeJ's code

  PACKET pow = { 2, U_NODE, NODE_RESET };

  return ( 0 );
}



int poweron_node ( int nodenum )
{                               //'Cold boot' function 
  PACKET pow = { 2, U_NODE, NODE_ON };


  return ( 0 );
}


int poweroff_node ( int nodenum )
{                               //'Power off the node' function

  PACKET pow = { 2, U_NODE, NODE_OFF };

  return ( 0 );
}



int powertoggle_node ( int node )
{                               //'Switch off and switch on' function


  PACKET pow = { 2, U_NODE, NODE_TOGGLE };



  return ( 0 );
}*/
