#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "net.h"
#include "syslogging.h"

bit enqueue ( QUEUE * pQueue, PACKET * pPacket, unsigned char ucPriority )
{
  unsigned int n;
  unsigned char i;

  n = pQueue->ucCount;

  if ( n > MAX_QUEUE_ELEMENTS )
    return ( QUEUE_ERROR );

  pQueue->Element[n].ucPriority = ucPriority;

  pQueue->Element[n].Packet.ucLength = pPacket->ucLength;
  pQueue->Element[n].Packet.ucUnit = pPacket->ucUnit;
  pQueue->Element[n].Packet.ucCode = pPacket->ucCode;
  for ( i = 0; i < ( pPacket->ucLength - 2 ); i++ )
    pQueue->Element[n].Packet.ucaData[i] = pPacket->ucaData[i];

  pQueue->ucCount++;
  if ( pQueue->ucCount > 8 ) {
    char tempstring[400];
    sprintf ( tempstring, "QCNT%d ", pQueue->ucCount );
    error_msg ( tempstring );
  }
  return ( QUEUE_SUCCESS );
}

PACKET *dequeue ( QUEUE * pQueue, unsigned char *pucPriority )
{
  unsigned char i, j, ucMaxPriority;

  if ( pQueue->ucCount ) {
    j = 0;                      // set index to maximum priority queue element
    ucMaxPriority = pQueue->Element[0].ucPriority;
    for ( i = 1; i < pQueue->ucCount; i++ )
      if ( pQueue->Element[i].ucPriority > ucMaxPriority ) {
        ucMaxPriority = pQueue->Element[i].ucPriority;
        j = i;
      }

    *pucPriority = pQueue->Element[j].ucPriority;
    pQueue->packet.ucLength = pQueue->Element[j].Packet.ucLength;
    pQueue->packet.ucUnit = pQueue->Element[j].Packet.ucUnit;
    pQueue->packet.ucCode = pQueue->Element[j].Packet.ucCode;
    for ( i = 0; i < ( pQueue->Element[j].Packet.ucLength - 2 ); i++ )
      pQueue->packet.ucaData[i] = pQueue->Element[j].Packet.ucaData[i];

    for ( i = j; i < ( pQueue->ucCount - 1 ); i++ )
      pQueue->Element[i] = pQueue->Element[i + 1];

    pQueue->ucCount--;

    return ( &pQueue->packet );
  } else
    return ( NULL );
}
