#include <stdio.h>
#include <syslog.h>
#include <stdlib.h>

extern int nodaemon;
extern const char *program_name;

void error_msg ( char *error )
{
  if ( nodaemon )
    fprintf ( stderr, "%s", error );
  //else    // syslog should occur regardless of debug activity. 
  syslog ( LOG_DAEMON | LOG_ERR, "%s\n", error );
}

void exit_msg ( char *error )   // report a fatal error and exit immediately
     // to be used only before the thread spins off.
{
  fprintf ( stderr, "%s: %s\nNodewatch exiting.\n", program_name, error );
  syslog ( LOG_DAEMON | LOG_ERR, "%s\nNodewatch exiting.\n", error );
  exit ( 1 );
}

void info_msg ( char *error )
{
  if ( nodaemon )
    fprintf ( stderr, "%s", error );
  // else  // syslog should occur regardless of debug activity.
  syslog ( LOG_DAEMON | LOG_INFO, "%s\n", error );
}
