#define DATFILE "/var/www/html/ganglia/data/nodewatch.dat"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
enum {E_NORMAL,E_USAGE,E_ERROR,E_INVALID_NODE, E_NOFILE};

//above entry is added through install script
#define MAX_NODE 254
#define STRING_LENGTH 200
#define MAX_LINES_PER_NODE 10

char *program_name;

void exit_program(int reason){
        if(reason==E_USAGE){
                fprintf(stderr, "Usage: %s <node number>\n",program_name);
                exit(reason);
        }
        exit(reason);
}

main(int argc, char *argv[]){
        int nodenum,counter;
        FILE *datfile;
        char tmpline[STRING_LENGTH];
	char expecting[STRING_LENGTH];
	
        program_name=argv[0];

        if(argc!=2) exit_program(E_USAGE);

        nodenum=atoi(argv[1]);
        if((nodenum<1) || (nodenum>MAX_NODE)) exit_program(E_INVALID_NODE);

        datfile=fopen(DATFILE,"r");
        if(datfile==NULL) exit_program(E_NOFILE);

	
        sprintf(expecting,"$NODE %d",nodenum);
	sprintf(tmpline,"gobleygook");
	while ((strncmp(tmpline,expecting,strlen(expecting))) != 0) {
		if(feof(datfile))exit_program(E_INVALID_NODE);
                fgets(tmpline,STRING_LENGTH,datfile);
	}
    	
	for(counter=1; counter<MAX_LINES_PER_NODE ; counter++){
		fgets(tmpline,STRING_LENGTH,datfile);
		if(strncmp(tmpline,"$NODE",5)==0) break;  //we're at another node.. we're all done
		if( (strncmp(tmpline,"$$FAN",5)==0) || (strncmp(tmpline,"$$TEMP",6)==0) || (strncmp(tmpline,"$$VOLT",6)==0) ){
			printf("%s",tmpline);
		}
	}
}
