/*wrapper for running reboot, etc as root
  
  usage:  wrapper <username> <encrypted password> <command> <arg1> <arg2> ... <argX>
*/


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <shadow.h>
#include <security/pam_appl.h>
#include <security/pam_misc.h>
#include <security/pam_appl.h>
#include <security/pam_misc.h>
#include <pwd.h>
#include <popt.h>
#include <pwd.h>

#define MAX_STRING 2000

static struct pam_conv conv;

enum { EXIT_NORMAL, EXIT_OPTIONS, EXIT_UNAUTH, EXIT_BADCOMMAND , EXIT_BADFILE};

static int stdin_conv (int num_msg, const struct pam_message **msgm, struct pam_response **response, void *appdata_ptr);

static int stdin_conv (int num_msg, const struct pam_message **msgm, struct pam_response **response, void *appdata_ptr) {
    struct pam_response *reply;
    int count;
  
    if (num_msg <= 0) return PAM_CONV_ERR;
  
    reply = (struct pam_response *) calloc (num_msg, sizeof (struct pam_response));
    if (reply == NULL) return PAM_CONV_ERR;
  
    for (count = 0; count < num_msg; ++count) {
      reply[count].resp_retcode = 0;
      reply[count].resp = strdup (appdata_ptr);
    }
  
    *response = reply;
    reply = NULL;
  
    return PAM_SUCCESS;
}

void usage (int status) {
    fprintf (stderr, "Usage:   wrapper <username> <command> <arg1> ... <argX>\n");
    exit (status);
}

int is_authorized (char *name) {	//checks /etc/mcms.users
    FILE *list;
    char username[200];
  
    list = fopen ("/etc/mcms.users", "ro");
    if (list==NULL) {
        fprintf(stderr,"Error opening user list\n");
        exit(EXIT_BADFILE);
    }
    while (!feof (list)) {
        fscanf (list, "%s\n", username);
        if (strcmp (username, name) == 0) return 1;
    }
    return 0;
}

int main (int argc, char *argv[]) {
    char *username_given, passwd_given[200];
    int i, retval;
    FILE *myinput;
    struct spwd *user;
    struct pam_conv conv;
    pam_handle_t *pamh = NULL;
    char *environment[2];
    char command[MAX_STRING]="",tmpcmd[MAX_STRING]="";
  
    if (argc < 3) usage (EXIT_OPTIONS);
  
    username_given = argv[1];
    user = getspnam (username_given);
  
  
    if (user == NULL) {
        fprintf (stderr, "Nonexistant user\n");
        exit (EXIT_UNAUTH);
    }
  
    if (!is_authorized (username_given)) {
        fprintf (stderr, "Unauthorized user\n");
        exit (EXIT_UNAUTH);
    }
  
    fgets(passwd_given,200,stdin);
    passwd_given[(strlen (passwd_given) -1)] = '\0';

    conv.appdata_ptr = strdup(passwd_given);
    conv.conv = stdin_conv;
  
    retval = pam_start ("passwd", username_given, &conv, &pamh);
    retval = pam_authenticate (pamh, 0);
    if (retval != PAM_SUCCESS) {
        printf ("Invalid password\n");
        exit (-1);
    }
  
    fflush(stdout);
    setuid(0);
    setgid(0);
    environment[0]=strdup("PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin");
    environment[1]=NULL;
    argv[0]=strdup("/bin/sh");
    argv[1]=strdup("-c");
    for(i=2;i<argc;i++) {
      if(snprintf(command,MAX_STRING-1,"%s %s",tmpcmd,argv[i])>(MAX_STRING-1)) {
          fprintf(stderr,"Maximum command length of %d exceeded. Exiting.\n",MAX_STRING);
          exit(255);
      }
      strcpy(tmpcmd,command);
    }
    argv[2]=command;
    argv[3]=NULL;
    return execve(argv[0],argv,environment);
}
